#ifndef _HDLPHOOK_H_
#define _HDLPHOOK_H_

// private
// typedef enum _MEMORY_INFORMATION_CLASS
// {
// 	MemoryBasicInformation = 0,
// 	MemoryWorkingSetInformation,
// 	MemoryMappedFilenameInformation,
// 	MemoryRegionInformation,
// 	MemoryWorkingSetExInformation,
// 	MemorySharedCommitInformation
// } MEMORY_INFORMATION_CLASS;

//
// SYSTEM_INFORMATION_CLASS definition
//
typedef enum _SYSTEM_INFORMATION_CLASS
{
	SystemBasicInformation		= 0,
	SystemProcessInformation	= 5,
	SystemModuleInformation		= 11,
}SYSTEM_INFORMATION_CLASS;


typedef struct _RTL_PROCESS_MODULE_INFORMATION
{
	HANDLE Section;
	PVOID MappedBase;
	PVOID ImageBase;
	ULONG ImageSize;
	ULONG Flags;
	USHORT LoadOrderIndex;
	USHORT InitOrderIndex;
	USHORT LoadCount;
	USHORT OffsetToFileName;
	UCHAR FullPathName[256];
} RTL_PROCESS_MODULE_INFORMATION, *PRTL_PROCESS_MODULE_INFORMATION;

typedef struct _RTL_PROCESS_MODULES
{
	ULONG NumberOfModules;
	RTL_PROCESS_MODULE_INFORMATION Modules[1];
} RTL_PROCESS_MODULES, *PRTL_PROCESS_MODULES;

// symbols
typedef struct _SECTION_IMAGE_INFORMATION
{
	PVOID TransferAddress;
	ULONG ZeroBits;
	SIZE_T MaximumStackSize;
	SIZE_T CommittedStackSize;
	ULONG SubSystemType;
	union
	{
		struct
		{
			USHORT SubSystemMinorVersion;
			USHORT SubSystemMajorVersion;
		};
		ULONG SubSystemVersion;
	};
	ULONG GpValue;
	USHORT ImageCharacteristics;
	USHORT DllCharacteristics;
	USHORT Machine;
	BOOLEAN ImageContainsCode;
	union
	{
		UCHAR ImageFlags;
		struct
		{
			UCHAR ComPlusNativeReady : 1;
			UCHAR ComPlusILOnly : 1;
			UCHAR ImageDynamicallyRelocated : 1;
			UCHAR ImageMappedFlat : 1;
			UCHAR BaseBelow4gb : 1;
			UCHAR Reserved : 3;
		};
	};
	ULONG LoaderFlags;
	ULONG ImageFileSize;
	ULONG CheckSum;
} SECTION_IMAGE_INFORMATION, *PSECTION_IMAGE_INFORMATION;

// typedef struct _MEMORY_BASIC_INFORMATION {
// 	PVOID BaseAddress;
// 	PVOID AllocationBase;
// 	DWORD AllocationProtect;
// 	SIZE_T RegionSize;
// 	DWORD State;
// 	DWORD Protect;
// 	DWORD Type;
// } MEMORY_BASIC_INFORMATION, *PMEMORY_BASIC_INFORMATION;

typedef struct _PROCESS_INFO{
	HANDLE ProcessId;
	BOOLEAN IsWow64Process;
}PROCESS_INFO, *PPROCESS_INFO;

typedef struct _WORKITEM_PARAMETER
{
	KEVENT Event;
	PIO_WORKITEM IoWorkItem;
	HANDLE ProcessId;
	BOOLEAN IsWow64Process;
	IMAGE_INFO *ImageInfo;
}WORKITEM_PARAMETER, *PWORKITEM_PARAMETER;
//
// System didn't export function declaration
//
NTSYSAPI
NTSTATUS
NTAPI ZwQuerySystemInformation(
	__in		SYSTEM_INFORMATION_CLASS SystemInformationClass,
	__inout		PVOID SystemInformation,
	__in		ULONG SystemInformationLength,
	__out_opt	PULONG ReturnLength
	);

NTSYSAPI
NTSTATUS
NTAPI ZwQueryInformationProcess(
	__in		HANDLE ProcessHandle,
	__in		PROCESSINFOCLASS ProcessInformationClass,
	__out		PVOID ProcessInformation,
	__in		ULONG ProcessInformationLength,
	__out_opt	PULONG ReturnLength
	);

typedef
NTSTATUS
(NTAPI *_ZwReadVirtualMemory)(
	IN	HANDLE ProcessHandle,
	IN	PVOID BaseAddress,
	OUT	PVOID Buffer,
	IN	ULONG NumberOfBytesToRead,
	OUT PULONG NumberOfBytesReaded OPTIONAL
	);

typedef
NTSTATUS
(NTAPI *_ZwWriteVirtualMemory)(
	IN	HANDLE ProcessHandle,
	IN	PVOID BaseAddress,
	IN	PVOID Buffer,
	IN	ULONG NumberOfBytesToWrite,
	OUT PULONG NumberOfBytesWritten OPTIONAL
	);

typedef
NTSTATUS
(NTAPI *_ZwQueryVirtualMemory)(
	IN	HANDLE ProcessHandle,
	IN	PVOID BaseAddress,
	IN	MEMORY_INFORMATION_CLASS MemoryInformationClass,
	OUT PVOID MemoryInformation,
	IN	ULONG MemoryInformationLength,
	OUT PULONG ReturnLength OPTIONAL
	);

typedef
NTSTATUS
(NTAPI *_ZwProtectVirtualMemory)(
	IN		HANDLE ProcessHandle,
	IN	OUT PVOID *BaseAddress,
	IN	OUT PSIZE_T NumberOfBytesToProtect,
	IN		ULONG NewAccessProtection,
	OUT		PULONG OldAccessProtecton
	);


#endif // _HDLPHOOK_H